var tables = {
	rowCount: 0,
	columnCount: 0,
	title: '',
	headerTitles: [],
	rowData: [],
	maxRowsSet: false,
	isColCountSet: false,
	setTitle: function(title) {
		this.title = title;
	},

	createTable: function(id) {
		var head = $('<thead />');

		for (var i = 0; i < this.columnCount; i++) {
			var th = $('<th />');
			if(this.headerTitles[i])
				th.text(this.headerTitles[i]);

			head.append(th);
		};

		var table = $('<table class="tables-js" />').css({
			width: '100%'
		});

		table.append(head);

		var wrap = $('<div class="table-wrapper"/>');
		wrap.append(
				$('<strong />').text(this.title)
			);

		wrap.append(table)

		id = $('#'+id);

		$(id).append(wrap);

		this._onCreate();
	},

	setColumnCount: function(n) {
		this.columnCount = n;
		this.isColCountSet = true;
	},

	setHeaderTitles: function(headerTitles) {
		if(!this._validate)
			return ;
		
		if(headerTitles.length != this.columnCount)
			console.error('Wrong headerTitles arguments given.')
		this.headerTitles = headerTitles;
	},

	setRowCount: function(n) {
		this.rowCount = n;
		this.maxRowsSet = true;
	},

	addRow: function() {
		if(!this._validate)
			return ;
	
		var rowData = [];
		for(var i = 0; i < this.columnCount; i++)	
			rowData.push(arguments[i]);

		this.rowData.push(rowData);
	},

	addRowFromString: function(rowString) {
		if(!this._validate)
			return ;

		var arr = rowString.split(";");

		if(this.columnCount !== arr.length) {
			console.error('Malformed string format "'+ rowString +'".');
			return ;
		}

		this.rowData.push(arr);

	},

	addRowsJson: function(json) {
		if(!this._validate)
			return ;

		var arr = [], error;

		for (var i = 0; i < json.length; i++) {
			if(json[i].length != this.columnCount) {
				console.error('Wrong json. Column count does not match!');
				return ;
			}
			
			arr.push(json[i]);
		};

		this.rowData = this.rowData.concat(arr);
	},

	_validate: function () {
		if(!this.isColCountSet) {
			console.error('You have to set comlum count first. Use "setColumnCount" function.');4
			return false;
		}
		return true;
	},

	_onCreate: function () {
		var _this = this;

		_this._reRenderBody();

		$('.tables-js th').click(function () {
			var tempArr = [];
			var th = $(this);
			var index = $('.tables-js th').index(th);
			for (var i = _this.rowData.length - 1; i >= 0; i--) {
				tempArr.push(_this.rowData[i][index]);
			};

			var temdirect1 = -1;
			var temdirect2 =  1; 
			if(th.hasClass('acending')) {
				temdirect1 = 1;
				temdirect2 = -1;
				th.removeClass('acending');
			} else {
				th.addClass('acending');
			}


			_this.rowData = _this.rowData.sort(function (prev, next){
				if (prev[index] < next[index]) 
					return -1;
				if (prev[index] > next[index]) 
					return 1;
				return 0;
			});

			_this._reRenderBody();
			th.addClass('sorted');
		});
	},
	_reRenderBody: function () {
			var body = $('<tbody />');
			$('.tables-js tbody').remove();

			for (var i = 0; i < this.rowData.length; i++) {
				var tr = $('<tr />');

				for (var j = 0; j < this.columnCount; j++) {
					tr.append($('<td/>').html(this.rowData[i][j]));
				};

				body.append(tr);

				if(this.rowCount == (i+1) && this.maxRowsSet)
					break;
			}

			$('.tables-js').append(body);
	}
}
